require "rails_admin_pick_up"

require "rails_admin_opening/engine"

module RailsAdminOpening
  # Your code goes here...
end

require 'rails_admin/config/actions'

module RailsAdmin
  module Config
    module Actions
      class Opening < Base
        RailsAdmin::Config::Actions.register(self)
        
        
        register_instance_option :object_level do
          false
        end
        # This ensures the action only shows up for Users
        register_instance_option :visible? do
          # visible only if authorized and if the object has a defined method
          authorized? #&& bindings[:abstract_model].model == ChosenItem && bindings[:abstract_model].model.column_names.include?("barcode")
        end
        # We want the action on members, not the Users collection
        register_instance_option :member do
          false
        end

        register_instance_option :collection do
          false
        end
        register_instance_option :root? do
          true
        end

        register_instance_option :breadcrumb_parent do
          # if root?
          #   [:dashboard]
          # elsif collection?
          #   [:index, bindings[:abstract_model]]
          # elsif member?
          #   [:show, bindings[:abstract_model], bindings[:object]]
          # end
          [nil]
        end

        register_instance_option :link_icon do
          'icon-barcode'
        end
        # You may or may not want pjax for your action
        register_instance_option :pjax? do
          true
        end
        
        register_instance_option :controller do
          Proc.new do # In modo che venga valutata ogni volta che viene chiamata
            if request.xhr? && !params["_pjax"]# Nel caso si voglia usare anche una interazione javascript
              message, status = CheckOrChangeStatus.perform params[:barcode], :pick_up, :opening, _current_user.id
              
              render json: MultiJson.dump(message), status: status
            end
          end
        end
      end
    end
  end
end
